=== modified file 'decorations/DecorationsWindowButton.cpp'
--- decorations/DecorationsWindowButton.cpp	2016-08-02 11:03:26 +0000
+++ decorations/DecorationsWindowButton.cpp	2016-08-02 11:13:51 +0000
@@ -110,36 +110,53 @@
           win_->minimize();
         break;
       case WindowButtonType::MAXIMIZE:
+        switch (button)
+        {
+          case Button1:
+            if (win_->actions() & (CompWindowActionMaximizeHorzMask|CompWindowActionMaximizeVertMask))
+              win_->maximize(MAXIMIZE_STATE);
+            break;
+          case Button2:
+            if (win_->actions() & CompWindowActionMaximizeVertMask)
+            {
+              if (!(win_->state() & CompWindowStateMaximizedVertMask))
+                win_->maximize(win_->state() | CompWindowStateMaximizedVertMask);
+            }
+            break;
+          case Button3:
+            if (win_->actions() & CompWindowActionMaximizeHorzMask)
+            {
+              if (!(win_->state() & CompWindowStateMaximizedHorzMask))
+                win_->maximize(win_->state() | CompWindowStateMaximizedHorzMask);
+            }
+            break;
+        }
+        break;
       case WindowButtonType::UNMAXIMIZE:
         switch (button)
         {
           case Button1:
-            if ((win_->state() & CompWindowStateMaximizedVertMask) ||
-                (win_->state() & CompWindowStateMaximizedHorzMask))
               win_->maximize(0);
-            else if (win_->actions() & (CompWindowActionMaximizeHorzMask|CompWindowActionMaximizeVertMask))
-              win_->maximize(MAXIMIZE_STATE);
             break;
           case Button2:
             if (win_->actions() & CompWindowActionMaximizeVertMask)
             {
               if (!(win_->state() & CompWindowStateMaximizedVertMask))
-                win_->maximize(CompWindowStateMaximizedVertMask);
+                win_->maximize(win_->state() | CompWindowStateMaximizedVertMask);
               else
-                win_->maximize(0);
+                win_->maximize(win_->state() & ~CompWindowStateMaximizedVertMask);
             }
             break;
           case Button3:
             if (win_->actions() & CompWindowActionMaximizeHorzMask)
             {
               if (!(win_->state() & CompWindowStateMaximizedHorzMask))
-                win_->maximize(CompWindowStateMaximizedHorzMask);
+                win_->maximize(win_->state() | CompWindowStateMaximizedHorzMask);
               else
-                win_->maximize(0);
+                win_->maximize(win_->state() & ~CompWindowStateMaximizedHorzMask);
             }
             break;
         }
-        break;
       default:
         break;
     }

